{------------------------------------------------------------
Exemple de rcupration de Handle avec FindWindow et
FindWindowEx, et rcupration de texte d'un Edit d'une
application externe

Adrien Montfaucon

Suggestions, erreurs, questions : am-vector@laposte.net
-------------------------------------------------------------}
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

{------------------------------------------------------------
ATTENTION : S'il y a plusieurs instances de l'Explorateur ou
d'Internet Explorer, ce code prendra la premire fentre dans
l'ordre Z, si l'on veut slectionner la bonne fentre, il faut
utiliser un autre code
-------------------------------------------------------------}

//Rcupration du dossier actuel de l'Explorateur Windows
function GetCurrentExplorerDir:String;
var Explorer,ClientWork,Toolbar,ComboBox,ComboBoxChild,Edit:HWND;
  Mem:Integer;
begin
//Retrouve le Handle de la fentre principale
Explorer:=FindWindow('ExploreWClass',nil);
if Explorer=0 then
  //Si la fentre n'existe pas
  Result:=''
else
  begin
  //Cherche le Handle de la fentre de travail
  ClientWork:=FindWindowEx(Explorer,0,'WorkerA',nil);
  if ClientWork=0 then
    //Compatibilit XP / 98
    ClientWork:=FindWindowEx(Explorer,0,'WorkerW',nil);
  //Retrouve le Handle de la ToolBar
  Toolbar:=FindWindowEx(ClientWork,0,'ReBarWindow32',nil);
  //Cherche le Handle du ComboBox
  ComboBox:=FindWindowEx(Toolbar,0,'ComboBoxEx32', nil);
  ComboBoxChild:=FindWindowEx(ComboBox,0,'ComboBox',nil);
  //Atteint l'Edit et envoie un message pour avoir le texte
  Edit:=FindWindowEx(ComboBoxChild,0,'Edit',nil);
  Mem:=SendMessage(Edit,WM_GETTEXTLENGTH,0,0)+1;
  SetLength(Result,Mem);
  //Envoi du message
  SendMessage(Edit,WM_GETTEXT,Mem,Integer(@Result[1]));
  end;
end;

//Rcupration de l'URL en cours dans Internet Explorer
function GetCurrentInternetExplorerURL:String;
var Explorer,ClientWork,Toolbar,ComboBox,ComboBoxChild,Edit:HWND;
  Mem:Integer;
begin
//Retrouve le Handle de la fentre principale
Explorer:=FindWindow('IEFrame',nil);
if Explorer=0 then
  Result:=''
else
  begin
  //Cherche le Handle de la fentre de travail
  ClientWork:=FindWindowEx(Explorer,0,'WorkerA',nil);
  if ClientWork=0 then
    //Compatibilit XP / 98
    ClientWork:=FindWindowEx(Explorer,0,'WorkerW',nil);
  //Retrouve le Handle de la ToolBar
  Toolbar:=FindWindowEx(ClientWork,0,'ReBarWindow32',nil);
  //Cherche le Handle du ComboBox
  ComboBox:=FindWindowEx(Toolbar,0,'ComboBoxEx32', nil);
  ComboBoxChild:=FindWindowEx(ComboBox,0,'ComboBox',nil);
  //Atteint l'Edit et envoie un message pour avoir le texte
  Edit:=FindWindowEx(ComboBoxChild,0,'Edit',nil);
  Mem:=SendMessage(Edit,WM_GETTEXTLENGTH,0,0)+1;
  SetLength(Result,Mem);
  //Envoi du message
  SendMessage(Edit,WM_GETTEXT,Mem,Integer(@Result[1]));
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var Explorer, IE: String;
begin
Explorer:=GetCurrentExplorerDir;
IE:=GetCurrentInternetExplorerURL;
if IE<>'' then
  Label1.Caption:='Internet Explorer : '+IE;
if Explorer<>'' then
  Label2.Caption:='Explorateur Windows : '+Explorer;
end;

end.
 